/*
͸
 Source file: DBFNSX.CH                                                   
 Description: #Include file for HiPer-SIx v1.1 for Clipper 5.2x           
 Notes      : Include this file (#include "SIXNSX.CH") in your program's  
              source code to use HiPer-SIx v1.1.                          
 Last Update: 12/01/93                                                    
 Notice     : Copyright 1992, 1993 - SuccessWare 90, Inc.                 
;
  
*/

REQUEST DBFNSX

#command SET ORDER TO TAG <(tag)> [OF <(cdx)>]                             ;
      => ordSetFocus( <(tag)> [, <(cdx)>] )

#command SET TAG TO <tag> [OF <(cdx)>]                                     ;
      => ordSetFocus( <(tag)> [, <(cdx)>] )

#command SET TAG TO                                                        ;
      => ordSetFocus( 0 )

#command SUBINDEX ON <key> TO <(file)>                                     ;
         [FOR <for>]                                                       ;
         [<all:   ALL>]                                                    ;
         [WHILE   <while>]                                                 ;
         [NEXT    <next>]                                                  ;
         [RECORD  <rec>]                                                   ;
         [<rest:  REST>]                                                   ;
         [<u:     UNIQUE>]                                                 ;
         [OPTION  <opt> [STEP <step>]]                                     ;
         [EVAL    <opt> [EVERY <step>]]                                    ;
         [<add:   ADDITIVE>]                                               ;
         [<filt:  FILTERON>]                                               ;
         [NOOPTIMIZE]                                                      ;
                                                                           ;
      => ordCondSet( <"for">, <{for}>,                                     ;
                      if( <.all.>, .t., NIL ),                             ;
                      <{while}>,                                           ;
                      <{opt}>, <step>    ,                                 ;
                      RECNO(), <next>, <rec>,                              ;
                      if( <.rest.>, .t., NIL ),                            ;
                      NIL, .f., NIL, .t., NIL, NIL, <.add.>, NIL,          ;
                      <.filt.>)                                            ;
       ; dbCreateIndex(<(file)>, <"key">, <{key}>,                         ;
                        if(<.u.>, .t., NIL))                               ;


#command SUBINDEX ON <key> TAG <(tag)> [OF <(nsx)>]                        ;
         [FOR <for>]                                                       ;
         [<all:   ALL>]                                                    ;
         [WHILE   <while>]                                                 ;
         [NEXT    <next>]                                                  ;
         [RECORD  <rec>]                                                   ;
         [<rest:  REST>]                                                   ;
         [<u:     UNIQUE>]                                                 ;
         [OPTION  <opt> [STEP <step>]]                                     ;
         [EVAL    <opt> [EVERY <step>]]                                    ;
         [<add:   ADDITIVE>]                                               ;
         [<filt:  FILTERON>]                                               ;
         [NOOPTIMIZE]                                                      ;
                                                                           ;
      => ordCondSet(<"for">, <{for}>,                                      ;
                      if( <.all.>, .t., NIL ),                             ;
                      <{while}>,                                           ;
                      <{opt}>, <step>    ,                                 ;
                      RECNO(), <next>, <rec>,                              ;
                      if( <.rest.>, .t., NIL ),                            ;
                      NIL, .t., <(nsx)>, .t., NIL, NIL, <.add.>, NIL,      ;
                      <.filt.>)                                            ;
       ; ordCreate(<(nsx)>, <(tag)>, <"key">, <{key}>,                     ;
                        if(<.u.>, .t., NIL))                               ;

#command INDEX ON <key> TO <(file)>                                        ;
         [FOR <for>]                                                       ;
         [<all:   ALL>]                                                    ;
         [WHILE   <while>]                                                 ;
         [NEXT    <next>]                                                  ;
         [RECORD  <rec>]                                                   ;
         [<rest:  REST>]                                                   ;
         [<u:     UNIQUE>]                                                 ;
         [<cur:   USECURRENT>]                                             ;
         [<cur:   SUBINDEX>]                                               ;
         [OPTION  <opt> [STEP <step>]]                                     ;
         [EVAL    <opt> [EVERY <step>]]                                    ;
         [<add:   ADDITIVE>]                                               ;
         [<filt:  FILTERON>]                                               ;
         [NOOPTIMIZE]                                                      ;
                                                                           ;
      => ordCondSet(<"for">, <{for}>,                                      ;
                      if( <.all.>, .t., NIL ),                             ;
                      <{while}>,                                           ;
                      <{opt}>, <step>    ,                                 ;
                      RECNO(), <next>, <rec>,                              ;
                      if( <.rest.>, .t., NIL ),                            ;
                      NIL, .f., NIL, <.cur.>, NIL, NIL, <.add.>, NIL,      ;
                      <.filt.>)                                            ;
       ; dbCreateIndex(<(file)>, <"key">, <{key}>,                         ;
                        if(<.u.>, .t., NIL))                               ;


#command INDEX ON <key> TAG <(tag)> [OF <(nsx)>]                           ;
         [FOR <for>]                                                       ;
         [<all:   ALL>]                                                    ;
         [WHILE   <while>]                                                 ;
         [NEXT    <next>]                                                  ;
         [RECORD  <rec>]                                                   ;
         [<rest:  REST>]                                                   ;
         [<u:     UNIQUE>]                                                 ;
         [<cur:   USECURRENT>]                                             ;
         [<cur:   SUBINDEX>]                                               ;
         [OPTION  <opt> [STEP <step>]]                                     ;
         [EVAL    <opt> [EVERY <step>]]                                    ;
         [<add:   ADDITIVE>]                                               ;
         [<filt:  FILTERON>]                                               ;
         [NOOPTIMIZE]                                                      ;
                                                                           ;
      => ordCondSet(<"for">, <{for}>,                                      ;
                      if( <.all.>, .t., NIL ),                             ;
                      <{while}>,                                           ;
                      <{opt}>, <step>    ,                                 ;
                      RECNO(), <next>, <rec>,                              ;
                      if( <.rest.>, .t., NIL ),                            ;
                      NIL, .t., <(nsx)>, <.cur.>, NIL, NIL, <.add.>,       ;
                      NIL, <.filt.>)                                       ;
       ; ordCreate(<(nsx)>, <(tag)>, <"key">, <{key}>,                     ;
                        if(<.u.>, .t., NIL))                               ;

#command REINDEX                                                           ;
         [EVAL    <opt> [EVERY <step>]]                                    ;
         [OPTION  <opt> [STEP <step>]]                                     ;
      => ordCondSet(,,,, <{opt}>, <step>,,,,,,,,,,,)                       ;
       ; dbReindex()

#command DELETE TAG <(tag1)> [OF <(cdx1)>]                                 ;
         [, <(tagn)> [OF <(cdxn)>]]                                        ;
      => ordDestroy( <(tag1)>, <(cdx1)> )                                  ;
      [; ordDestroy( <(tagn)>, <(cdxn)> )]

#command DELETE TAG ALL [OF <(cdx)>]                                       ;
      => Sx_KillTag( .t., <(cdx)> )

// Clear both values
#command CLEAR SCOPE                                                       ;
      => Sx_ClrScope()

// First value, inclusive
#xcommand SET SCOPETOP TO <value>                                          ;
      => Sx_SetScope(0, <value>)

#xcommand SET SCOPETOP TO                                                  ;
      => Sx_ClrScope(0)

// Last value, inclusive
#xcommand SET SCOPEBOTTOM TO <value>                                       ;
      => Sx_SetScope(1, <value>)

#xcommand SET SCOPEBOTTOM TO                                               ;
      => Sx_ClrScope(1)

// Clear both values
#command SET SCOPE TO                                                      ;
      => Sx_ClrScope()

// Both values, inclusive
#command SET SCOPE TO <value>                                              ;
      => Sx_SetScope(0, <value>)                                           ;
       ; Sx_SetScope(1, <value>)

#command SORT [TO <(file)>] [ON <fields,...>]                              ;
         [FOR <for>]                                                       ;
         [WHILE <while>]                                                   ;
         [NEXT <next>]                                                     ;
         [RECORD <rec>]                                                    ;
         [<rest:REST>]                                                     ;
         [ALL]                                                             ;
         [<cur: USECURRENT>]                                               ;
         [NOOPTIMIZE]                                                      ;
                                                                           ;
      => Sx_SortOption(<.cur.>)                                            ;
       ; __dbSort(<(file)>, { <(fields)> },                                ;
                   <{for}>, <{while}>, <next>, <rec>, <.rest.>)

